// tuneapp.


#include "AbstractItem.h"


AbstractItem::AbstractItem()
		: parent(NULL),
		target(AFFECT_ALL), postChangedOperation(PCO_NO),
		changed(NULL) {
}

ItemGroup* AbstractItem::getParent() const {
	return parent;
}

void AbstractItem::setParent(ItemGroup* parent) {
	this->parent = parent;
}

int AbstractItem::getAffectTarget() const {
	return target;
}

void AbstractItem::setAffectTarget(int target) {
	this->target = target;
}

Item::PostChangedOperation AbstractItem::getPostChangedOperation() const {
	return postChangedOperation;
}

void AbstractItem::setPostChangedOperation(Item::PostChangedOperation postChangedOperation) {
	this->postChangedOperation = postChangedOperation;
}

void AbstractItem::addPropertyChangeListener(PropertyChangeListener* listener) {
	properties.add(listener);
}

void AbstractItem::removePropertyChangeListener(PropertyChangeListener* listener) {
	properties.remove(listener);
}

void AbstractItem::firePropertyChange(const wstring& propertyName) {
	PropertyChangeEvent event(this, propertyName);
	for_each(properties.begin(), properties.end(),
			listener_fun<PropertyChangeListener, PropertyChangeEvent>(
			&PropertyChangeListener::propertyChange, event));
}

bool AbstractItem::isChanged() const {
	return changed;
}

void AbstractItem::setChanged() {
	changed = true;
}
