// tuneapp.


class AbstractItem;


#ifndef __ABSTRACT_ITEM_H__
#define __ABSTRACT_ITEM_H__


#include "Item.h"
#include "ItemGroup.h"
#include "AbstractCustomizer.h"

#include "util/EventListenerList.h"
#include "util/PropertyChangeListener.h"


class AbstractItem : public AbstractCustomizer, public virtual Item {
private:
	ItemGroup* parent;
	int target;
	PostChangedOperation postChangedOperation;
	EventListenerList<PropertyChangeListener> properties;
	bool changed;

protected:
	AbstractItem();

public:
	virtual ItemGroup* getParent() const;
	virtual void setParent(ItemGroup* parent);
	virtual int getAffectTarget() const;
	virtual void setAffectTarget(int target);
	virtual PostChangedOperation getPostChangedOperation() const;
	virtual void setPostChangedOperation(PostChangedOperation postChangedOperation);
	virtual void addPropertyChangeListener(PropertyChangeListener* listener);
	virtual void removePropertyChangeListener(PropertyChangeListener* listener);
	virtual bool isChanged() const;
	virtual void setChanged();

protected:
	void firePropertyChange(const wstring& propertyName);
};


#endif // __ABSTRACT_ITEM_H__
