// tuneapp.


#include "Category.h"


Category::Category() : parent(NULL), expand(false) {
}

Category* Category::getParent() const {
	return parent;
}

void Category::setParent(Category* parent) {
	this->parent = parent;
}

int Category::getAffectTarget() const {
	int target = Item::AFFECT_NO;
	for (	ItemGroupList::const_iterator groups = groupList.begin();
			groups != groupList.end();
			++groups) {
		target |= (*groups)->getAffectTarget();
	}
	for (	CategoryList::const_iterator categories = categoryList.begin();
			categories != categoryList.end();
			++categories) {
		target |= (*categories)->getAffectTarget();
	}
	return target;
}

void Category::addGroup(ItemGroup* group) {
	groupList.push_back(group);
}

const ItemGroupList& Category::getItemGroupList() const {
	return groupList;
}

void Category::addSubCategory(Category* subCategory) {
	categoryList.push_back(subCategory);
}

const CategoryList& Category::getSubCategoryList() const {
	return categoryList;
}

const wstring& Category::getShortHelpText() const {
	// Not Implemented.
	// return shortHelp;
	return NULL_STRING;
}

bool Category::isExpand() const {
	return expand;
}

void Category::setExpand(bool expand) {
	this->expand = expand;
}
