// tuneapp.


class Category;


#ifndef __CATEGORY_H__
#define __CATEGORY_H__


#include "types.h"
#include "AbstractCustomizer.h"
#include "ItemGroup.h"
#include "ConfigException.h"
#include "xml/Node.h"

#include <vector>
using namespace std;


class Category : public AbstractCustomizer {
private:
	Category* parent;
	ItemGroupList groupList;
	CategoryList categoryList;

	bool expand;

public:
	Category();
	Category* getParent() const;
	void setParent(Category* parent);
	int getAffectTarget() const;
	virtual void addGroup(ItemGroup* group);
	const ItemGroupList& getItemGroupList() const;
	void addSubCategory(Category* subCategory);
	const CategoryList& getSubCategoryList() const;
	bool isExpand() const;
	void setExpand(bool expand);

	virtual void setParams(xml::Node* params) throw(ConfigException) {}
	virtual const wstring& getShortHelpText() const;
};


#endif // __CATEGORY_H__
