// tuneapp.


#include "ClassRegistry.h"

#include "reg/DiskPerformanceCounterItem.h"
#include "reg/PriorityControlItem.h"
#include "reg/RegCheckItem.h"
#include "reg/RegDeleteSubKeysItem.h"
#include "reg/RegKeyItem.h"
#include "reg/RegMultiListValueItem.h"
#include "reg/RegMultiStringCheckItem.h"
#include "reg/RegMultiValueItem.h"
#include "reg/RegToggleItem.h"
#include "reg/RegValueItem.h"

#include "reg/nic/NICEnumerator.h"
#include "reg/nic/NICCheckItem.h"
#include "reg/nic/NICValueItem.h"
#include "reg/nic/RFC1323OptsItem.h"

#include "generic/ExecItem.h"

#include "generic/DummyItem.h"


ItemClassRegistry itemClassRegistry;
CategoryClassRegistry categoryClassRegistry;

// Bug work arround:
// VC++6
// can't get pointer to instantiated function template.
template<typename T>
struct CategoryFactory {
	static Category* categoryFactory() { return new T(); };
};
template<typename T>
struct ItemFactory {
	static Item* itemFactory() { return new T(); };
};

void registerClasses() {
// Bug work arround:
// '#' pre-processor operand unablable for unicode literal
	categoryClassRegistry.registerClass(L"tuneapp.reg.nic.NICEnumerator", &CategoryFactory<NICEnumerator>::categoryFactory);

	itemClassRegistry.registerClass(L"tuneapp.reg.DiskPerformanceCounterItem", &ItemFactory<DiskPerformanceCounterItem>::itemFactory);
	itemClassRegistry.registerClass(L"tuneapp.reg.PriorityControlItem", &ItemFactory<PriorityControlItem>::itemFactory);
	itemClassRegistry.registerClass(L"tuneapp.reg.RegCheckItem", &ItemFactory<RegCheckItem>::itemFactory);
	itemClassRegistry.registerClass(L"tuneapp.reg.RegDeleteSubKeysItem", &ItemFactory<RegDeleteSubKeysItem>::itemFactory);
	itemClassRegistry.registerClass(L"tuneapp.reg.RegKeyItem", &ItemFactory<RegKeyItem>::itemFactory);
	itemClassRegistry.registerClass(L"tuneapp.reg.RegMultiListValueItem", &ItemFactory<RegMultiListValueItem>::itemFactory);
	itemClassRegistry.registerClass(L"tuneapp.reg.RegMultiStringCheckItem", &ItemFactory<RegMultiStringCheckItem>::itemFactory);
	itemClassRegistry.registerClass(L"tuneapp.reg.RegMultiValueItem", &ItemFactory<RegMultiValueItem>::itemFactory);
	itemClassRegistry.registerClass(L"tuneapp.reg.RegToggleItem", &ItemFactory<RegToggleItem>::itemFactory);
	itemClassRegistry.registerClass(L"tuneapp.reg.RegValueItem", &ItemFactory<RegValueItem>::itemFactory);

	itemClassRegistry.registerClass(L"tuneapp.reg.nic.NICCheckItem", &ItemFactory<NICCheckItem>::itemFactory);
	itemClassRegistry.registerClass(L"tuneapp.reg.nic.NICValueItem", &ItemFactory<NICValueItem>::itemFactory);
	itemClassRegistry.registerClass(L"tuneapp.reg.nic.RFC1323OptsItem", &ItemFactory<RFC1323OptsItem>::itemFactory);

	itemClassRegistry.registerClass(L"tuneapp.generic.ExecItem", &ItemFactory<ExecItem>::itemFactory);

#ifdef _DEBUG
	itemClassRegistry.registerClass(L"tuneapp.generic.DummyItem", &ItemFactory<DummyItem>::itemFactory);
#endif // _DEBUG
}
