// tuneapp.


#ifndef __CONFIG_READER_H__
#define __CONFIG_READER_H__


#include "ConfigException.h"
#include "Item.h"
#include "ItemGroup.h"
#include "Category.h"
#include "IOException.h"

#include "xml/Document.h"
#include "xml/Node.h"

#include <string>
#include <vector>
#include <set>
using namespace std;


class ConfigReader {
public:
	static bool isElementName(const xml::Node* node, const wstring& name);

private:
	wstring baseDir;

	CategoryList categoryList;

public:
	ConfigReader(const wstring& baseDir);
	void readConfig() throw(ConfigException);
	CategoryList getResults();

private:
	void listDir(set<wstring>* files, const wstring& pattern);
	void loadDocument(const wstring& fileName, xml::Document* document) throw(IOException);
	void readConfig(xml::Document* document) throw(ConfigException);
	void readCategories(xml::Node* root) throw(ConfigException);
	Category* getCategory(const wstring& id, const wstring& className);
	Category* readCategory(xml::Node* root) throw(ConfigException);
	Category* includeCategory(const wstring& src) throw(ConfigException);
	Category* readCategoryConfig(xml::Document* root) throw(ConfigException);
	Category* readCategoryImpl(xml::Node* root) throw(ConfigException);
	ItemGroup* readItemGroup(xml::Node* root) throw(ConfigException);
	ItemGroup* readSigleItemGroup(xml::Node* root) throw(ConfigException);
	Item* readItem(xml::Node* root) throw(ConfigException);

	wstring getHelpText(xml::Node* root);
	void getHelpText(wstring* result, xml::Node* root);
};


#endif // __CONFIG_READER_H__
