// tuneapp.


class Item;


#ifndef __ITEM_H__
#define __ITEM_H__


#include "types.h"
#include "Customizer.h"
#include "ItemGroup.h"
#include "ConfigException.h"
#include "awt/Component.h"
#include "util/PropertyChangeListener.h"
#include "Storage.h"

#include "xml/Node.h"

#include <string>
using namespace std;


// interface
class Item : public virtual Customizer {
public:
	static const int AFFECT_NO;
	static const int AFFECT_SYSTEM;
	static const int AFFECT_USER;
	// static const int AFFECT_USER_POLICY;
	static const int AFFECT_ALL;

	enum PostChangedOperation {
		PCO_NO = 0,			// "no"
		PCO_LOGOFF = 1,		// "logoff"
		PCO_REBOOT = 2,		// "reboot"
	};

	static const wstring PROP_CURRENT_VALUE;
	static const wstring PROP_DEFAULT_VALUE;

public:
	virtual ~Item() {}
	virtual ItemGroup* getParent() const = 0;
	virtual void setParent(ItemGroup* parent) = 0;
	virtual int getAffectTarget() const = 0;
	virtual void setAffectTarget(int target) = 0;
	virtual PostChangedOperation getPostChangedOperation() const = 0;
	virtual void setPostChangedOperation(PostChangedOperation postChangedOperation) = 0;
	virtual void setParams(xml::Node* params) throw(ConfigException) = 0;

	virtual void addPropertyChangeListener(PropertyChangeListener* listener) = 0;
	virtual void removePropertyChangeListener(PropertyChangeListener* listener) = 0;

	virtual awt::Component* getViewComponent() = 0;

	virtual bool isChanged() const = 0;
	virtual void setDefault() = 0;
	virtual void apply() = 0;
	virtual void cancel() = 0;

	virtual void store(Storage* storage) = 0;
};


#endif // __ITEM_H__
