// tuneapp.


#include "ItemGroup.h"


ItemGroup::ItemGroup() : parent(NULL) {
}

void ItemGroup::setParent(Category* parent) {
	this->parent = parent;
}

Category* ItemGroup::getParent() const {
	return parent;
}

int ItemGroup::getAffectTarget() const {
	int target = Item::AFFECT_NO;
	for (	const_iterator items = begin();
			items != end();
			++items) {
		target |= (*items)->getAffectTarget();
	}
	return target;
}

void ItemGroup::addItem(Item* item) {
	itemList.push_back(item);
}

int ItemGroup::countItems() const {
	return itemList.size();
}

const ItemList& ItemGroup::getItemList() const {
	return itemList;
}

ItemGroup::const_iterator ItemGroup::begin() const {
	return itemList.begin();
}

ItemGroup::const_iterator ItemGroup::end() const {
	return itemList.end();
}

const wstring& ItemGroup::getShortHelpText() const {
	return shortHelp;
}

void ItemGroup::setShortHelpText(const wstring& shortHelp) {
	this->shortHelp = shortHelp;
}
