// tuneapp.


class ItemGroup;


#ifndef __ITEM_GROUP_H__
#define __ITEM_GROUP_H__


#include "Item.h"
#include "AbstractCustomizer.h"
#include "Category.h"

#include <vector>
using namespace std;


class ItemGroup : public AbstractCustomizer {
public:
	typedef ItemList::iterator iterator;
	typedef ItemList::const_iterator const_iterator;

private:
	Category* parent;
	ItemList itemList;
	wstring shortHelp;

public:
	ItemGroup();
	void setParent(Category* parent);
	Category* getParent() const;
	int getAffectTarget() const;
	void addItem(Item* item);
	int countItems() const;
	const ItemList& getItemList() const;
	const_iterator begin() const;
	const_iterator end() const;

	virtual const wstring& getShortHelpText() const;
	virtual void setShortHelpText(const wstring& shortHelp);
};


#endif // __ITEM_GROUP_H__
