// AWT less.


#ifndef __AWT_BORDER_LAYOUT_H__
#define __AWT_BORDER_LAYOUT_H__


#include "LayoutManager.h"


namespace awt {


class BorderLayout : public virtual LayoutManager {
private:

public:
	static const Constraints NORTH;
	static const Constraints SOUTH;
	static const Constraints EAST;
	static const Constraints WEST;
	static const Constraints CENTER;

protected:
	int hgap;
	int vgap;

	Component* north;
	Component* south;
	Component* east;
	Component* west;
	Component* center;

public:
	BorderLayout();

	void setHgap(int hgap);
	void setVgap(int vgap);

	void addLayoutComponent(Component* child, const Constraints& constraints) throw(IllegalArgumentException);
	void removeLayoutComponent(Component* child) throw(IllegalArgumentException);
	Dimension getPreferredLayoutSize(Container* parent);
	void layoutContainer(Container* parent);
};


} // namespace


#endif // __AWT_BORDER_LAYOUT_H__
