// AWT less.


#ifndef __AWT_CARD_LAYOUT_H__
#define __AWT_CARD_LAYOUT_H__


#include "LayoutManager.h"

#include <map>
using namespace std;


namespace awt {


class CardLayout : public virtual LayoutManager {
public:
	class Constraints : public LayoutManager::Constraints {
	private:
		const wstring name;
	public:
		Constraints(const wstring& name);
		const wstring& getName() const;
	};

protected:
	map<wstring, Component*> nameMap;
	Component* current;

public:
	CardLayout();

	void addLayoutComponent(Component* child, const LayoutManager::Constraints& constraints) throw(IllegalArgumentException);
	void removeLayoutComponent(Component* child);
	Dimension getPreferredLayoutSize(Container* parent);
	void layoutContainer(Container* parent);

	void show(Container* parent, const wstring& name) throw(IllegalArgumentException);
};


} // namespace


#endif // __AWT_CARD_LAYOUT_H__
