// AWT less.


#ifndef __AWT_CHECKBOX_H__
#define __AWT_CHECKBOX_H__


#include "Button.h"
#include "CheckboxGroup.h"
#include "event/ItemEventSource.h"


namespace awt {


class Checkbox : public Button, public virtual ItemEventSource {
protected:
	bool state;
	CheckboxGroup* group;

protected:
	virtual DWORD getWindowStyle();
	virtual HWND createWindow();

	virtual LRESULT wmCommand(WORD notifyMessage, WORD identifier, bool& consume);

public:
	Checkbox(const wstring& label = wstring(), bool state = false, CheckboxGroup* group = NULL);

	bool getState() const;
	void setState(bool state);
	CheckboxGroup* getGroup() const;

	virtual Dimension getPreferredSize();

private:
	void sendSetCheckMessage(HWND hwnd);
	void updateState();
};


} // namespace


#endif // __AWT_CHECKBOX_H__
