// AWT less.


#include "CheckboxGroup.h"
#include "Checkbox.h"
#include "Toolkit.h"

#include <assert.h>


namespace awt {


CheckboxGroup::CheckboxGroup() {
}

void CheckboxGroup::radioButtonAdded(Checkbox* radioButton) {
	assert (find(radioButtonList.begin(), radioButtonList.end(), radioButton) == radioButtonList.end());
	radioButtonList.push_back(radioButton);
	radioButton->addKeyListener(this);
}

void CheckboxGroup::keyPressed(KeyEvent& event) {
	if (event.getModifiers() == 0) {
		switch (event.getKeyCode()) {
		case VK_UP:
		case VK_LEFT:
			moveCheck(dynamic_cast<Checkbox*>(event.getSource()), false);
			event.consume();
			break;
		case VK_RIGHT:
		case VK_DOWN:
			moveCheck(dynamic_cast<Checkbox*>(event.getSource()), true);
			event.consume();
			break;
		}
	}
}

void CheckboxGroup::keyReleased(KeyEvent& event) {
}

void CheckboxGroup::keyTyped(KeyEvent& event) {
}

void CheckboxGroup::moveCheck(Checkbox* current, bool forward) {
	if (current == NULL) return;
	vector<Checkbox*>::const_iterator found
			= find(radioButtonList.begin(), radioButtonList.end(), current);
	if (found == radioButtonList.end()) return;
	if (forward) {
		if (++found == radioButtonList.end()) return;
	} else {
		if (found-- == radioButtonList.begin()) return;
	}
	current->setState(false);
	(*found)->setState(true);
	(*found)->requestFocus();
}


} // namespace
