// AWT less.


#ifndef __AWT_CHOICE_H__
#define __AWT_CHOICE_H__


#include "Component.h"
#include "event/ItemEventSource.h"

#include <vector>
using namespace std;


namespace awt {


class Choice : public virtual Component, public virtual ItemEventSource {
protected:
	vector<wstring> labelList;
	int selectedIndex;

protected:
	virtual LPCTSTR getWindowClass();
	virtual DWORD getWindowStyle();
	virtual HWND createWindow();

	virtual LRESULT wmCommand(WORD notifyMessage, WORD identifier, bool& consume);

public:
	Choice();

	void add(const wstring& label);
	void removeAll();
	int getSelectedIndex() const;
	void select(int index);

	void setSize(int width, int height);
	void setBounds(int x, int y, int width, int height);

	virtual Dimension getPreferredSize();

private:
	void sendAddMessage(HWND hwnd, const wstring& label);
	void sendSelectMessage(HWND hwnd);
	void updateSelectedIndex();
	void integrateSize();
};


} // namespace


#endif // __AWT_CHOICE_H__
