// AWT less.


#include "FitLayout.h"


namespace awt {


FitLayout* const FitLayout::sharedInstance = new FitLayout();


void FitLayout::addLayoutComponent(Component* child, const Constraints& constraints) {
}

void FitLayout::removeLayoutComponent(Component* child) {
}

Dimension FitLayout::getPreferredLayoutSize(Container* parent) {
	Insets insets = parent->getInsets();
	switch (parent->getComponentCount()) {
	case 0:
		return Dimension(insets.left + insets.right, insets.top + insets.bottom);
	case 1:
		{
			Dimension size = parent->getComponent(0)->getPreferredSize();
			size.width += insets.left + insets.right;
			size.height += insets.top + insets.bottom;
			return size;
		}
	default:
		throw Exception(L"FitLayout for single child container");
	}
}

void FitLayout::layoutContainer(Container* parent) {
	switch (parent->getComponentCount()) {
	case 0:
		return;
	case 1:
		{
			Dimension size = parent->getPreferredSize();
			Insets insets = parent->getInsets();
			parent->getComponent(0)->setBounds(
					insets.left,
					insets.top,
					size.width - insets.left - insets.right,
					size.height - insets.top - insets.bottom);
			return;
		}
	default:
		throw Exception(L"FitLayout for single child container");
	}
}


} // namespace
