// AWT less.


#ifndef __AWT_FLOW_LAYOUT_H__
#define __AWT_FLOW_LAYOUT_H__


#include "LayoutManager.h"


namespace awt {


class FlowLayout : public virtual LayoutManager {
public:
	enum Alignment {
		LEFT, RIGHT, CENTER
	};

protected:
	Alignment align;
	int hgap;
	int vgap;

public:
	FlowLayout(Alignment align = LEFT);
	FlowLayout(Alignment align, int hgap, int vgap);

	void setHgap(int hgap);
	void setVgap(int vgap);

	void addLayoutComponent(Component* child, const Constraints& constraints);
	void removeLayoutComponent(Component* child);
	Dimension getPreferredLayoutSize(Container* parent);
	void layoutContainer(Container* parent);
};


} // namespace


#endif // __AWT_FLOW_LAYOUT_H__
