// AWT less.


#ifndef __AWT_GRID_FLOW_LAYOUT_H__
#define __AWT_GRID_FLOW_LAYOUT_H__


#include "LayoutManager.h"

#include <vector>
using namespace std;


namespace awt {


class GridFlowLayout : public virtual LayoutManager {
public:
	enum Alignment {
		FIT, TOP, BOTTOM, LEFT, RIGHT, CENTER
	};

protected:
	Alignment halign;
	Alignment valign;
	Alignment cellHalign;
	Alignment cellValign;
	int rows;
	int cols;
	int hgap;
	int vgap;

public:
	GridFlowLayout(int rows, int cols);

	void setValign(Alignment valign);
	void setHalign(Alignment halign);
	void setCellValign(Alignment cellValign);
	void setCellHalign(Alignment cellHalign);
	void setHgap(int hgap);
	void setVgap(int vgap);

	void addLayoutComponent(Component* child, const Constraints& constraints);
	void removeLayoutComponent(Component* child);
	Dimension getPreferredLayoutSize(Container* parent);
	void layoutContainer(Container* parent);

private:
	int getRowsCount(Container* target);
	int getColsCount(Container* target);
	void getCellsSize(
			vector<int>* cellWidth, vector<int>* cellHeight,
			Container* parent);
	int getFullHeight(const vector<int>& cellHeight, Container* parent);
	int getFullWidth(const vector<int>& cellWidth, Container* parent);
	void fitLength(vector<int>* length, int gap, int target);
};


} // namespace


#endif // __AWT_GRID_FLOW_LAYOUT_H__
