// AWT less.


#ifndef __AWT_GRID_LAYOUT_H__
#define __AWT_GRID_LAYOUT_H__


#include "LayoutManager.h"


namespace awt {


class GridLayout : public virtual LayoutManager {
protected:
	int rows;
	int cols;
	int hgap;
	int vgap;

public:
	GridLayout(int rows, int cols);

	void setHgap(int hgap);
	void setVgap(int vgap);

	void addLayoutComponent(Component* child, const Constraints& constraints);
	void removeLayoutComponent(Component* child);
	Dimension getPreferredLayoutSize(Container* parent);
	void layoutContainer(Container* parent);

private:
	int getRowsCount(Container* parent);
	int getColsCount(Container* parent);
};


} // namespace


#endif // __AWT_GRID_LAYOUT_H__
