// AWT less.


#include "Label.h"

#include <assert.h>


namespace awt {


Label::Label(const wstring& text) : text(text) {
}

LPCTSTR Label::getWindowClass() {
	return L"STATIC";
}

LPCTSTR Label::getWindowText() {
	return text.c_str();
}

DWORD Label::getWindowStyle() {
	return SS_LEFT | SS_NOPREFIX | SS_NOTIFY |
			Component::getWindowStyle();
}

const wstring& Label::getText() {
	return text;
}

void Label::setText(const wstring& text) {
	if (this->text != text) {
		this->text = text;
		preferedSizeCache.width = -1;
		if (hwnd) {
			::SetWindowText(hwnd, text.c_str());
			repaint();
			relayoutRoot();
		}
	}
}

Dimension Label::getPreferredSize() {
	if (preferedSizeCache.width == -1) {
		Insets insets = getInsets();
		SIZE size;
		TEXTMETRIC metrics;
		getTextMetrics(text, &size, &metrics);
		preferedSizeCache.width = size.cx + insets.left + insets.right;
		preferedSizeCache.height = metrics.tmHeight + metrics.tmExternalLeading + insets.top + insets.bottom;
	}
	return preferedSizeCache;
}


} // namespace
