// AWT less.


#ifndef __AWT_LAYOUT_MANAGER_H__
#define __AWT_LAYOUT_MANAGER_H__


#include "types.h"
#include "../lang.h"


namespace awt {


class Component;
class Container;


// interface
class LayoutManager {
public:
	class Constraints {
	public:
		virtual ~Constraints() {}
	};

public:
	virtual ~LayoutManager() {};
	virtual void addLayoutComponent(Component* child, const Constraints& constraints) throw(IllegalArgumentException) = 0;
	virtual void removeLayoutComponent(Component* child) throw(IllegalArgumentException) = 0;
	virtual Dimension getPreferredLayoutSize(Container* parent) = 0;
	virtual void layoutContainer(Container* parent) throw(IllegalArgumentException) = 0;
};


} // namespace


#include "Component.h"
#include "Container.h"


#endif // __AWT_LAYOUT_MANAGER_H__
