// AWT less.


#ifndef __AWT_LIST_H__
#define __AWT_LIST_H__


#include "Component.h"
#include "event/ItemEventSource.h"

#include <vector>
using namespace std;


namespace awt {


class List : public virtual Component, public virtual ItemEventSource {
protected:
	vector<wstring> labelList;
	int selectedIndex;

protected:
	virtual LPCTSTR getWindowClass();
	virtual DWORD getWindowStyle();
	virtual DWORD getWindowStyleEx();
	virtual HWND createWindow();

	virtual LRESULT wmCommand(WORD notifyMessage, WORD identifier, bool& consume);

public:
	List();

	void add(const wstring& label);
	void removeAll();
	int getSelectedIndex() const;
	void select(int index);

	Dimension getPreferredSize();

private:
	void sendSelectMessage(HWND hwnd);
	void updateSelectedIndex();
};


} // namespace


#endif // __AWT_LIST_H__
