// AWT less.


#ifndef __AWT_TEXT_COMPONENT_H__
#define __AWT_TEXT_COMPONENT_H__


#include "Component.h"

#include "../util/EventListenerList.h"
#include "event/TextEvent.h"

#include <richedit.h>


namespace awt {


class TextListener;


/**
 *	Bug: don't update local text buffer before destroying window.
 */
class TextComponent: public virtual Component {
protected:
	mutable wstring text;
	bool editable;

	mutable bool windowTextUpdated;

private:
	EventListenerList<TextListener> textListeners;

protected:
	TextComponent(const wstring& text = wstring());

	virtual LPCTSTR getWindowClass();
	virtual LPCTSTR getWindowText();
	virtual DWORD getWindowStyle();
	virtual DWORD getWindowStyleEx();

	virtual LRESULT wmCommand(WORD notifyMessage, WORD identifier, bool& consume);
	virtual LRESULT wmNotify(UINT notifyCode, LPARAM lParam, bool& consume);

public:
	const wstring& getText() const;
	void setText(const wstring& text);
	void setCaretPosition(int pos);

	bool isEditaboe() const;
	void setEditable(bool editable);

	void addTextListener(TextListener* listener);
	void removeTextListener(TextListener* listener);

protected:
	void fireTextValueChanged();
};


} // namespace


#endif // __AWT_TEXT_COMPONENT_H__
