// AWT less.


#include "TextField.h"

#include <assert.h>


namespace awt {


TextField::TextField(int cols) : cols(cols) {
}

TextField::TextField(const wstring& text, int cols) : TextComponent(text), cols(cols) {
}

DWORD TextField::getWindowStyle() {
	return ES_AUTOHSCROLL |
			TextComponent::getWindowStyle();
}

HWND TextField::createWindow() {
	HWND hwnd = TextComponent::createWindow();
	// ::SendMessage(hwnd, EM_LIMITTEXT, cols, 0);
	return hwnd;
}

void TextField::setColumns(int cols) {
	if (this->cols != cols) {
		this->cols = cols;
		relayoutRoot();
	}
}

Dimension TextField::getPreferredSize() {
	if (preferedSizeCache.width == -1) {
		assert (hwnd != NULL);
		auto_hdc hdc(hwnd);
		selectFont(hdc);
		TEXTMETRIC metrics;
		::GetTextMetrics(hdc, &metrics);
		int borderW = ::GetSystemMetrics(SM_CXEDGE) + ::GetSystemMetrics(SM_CXBORDER);
		int borderH = ::GetSystemMetrics(SM_CYEDGE) + ::GetSystemMetrics(SM_CYBORDER);
		preferedSizeCache.width = metrics.tmAveCharWidth * cols + borderW * 2;
		preferedSizeCache.height = metrics.tmHeight + borderH * 2;
	}
	return preferedSizeCache;
}


} // namespace
