// AWT less.


#ifndef __AWT_WINDOW_H__
#define __AWT_WINDOW_H__


#include "Container.h"
#include "../util/EventListenerList.h"


namespace awt {


class WindowListener;


class Window : public virtual Container {
protected:
	Dimension minimumSize;

private:
	EventListenerList<WindowListener> windowListeners;

	Component* mouseOwner;

protected:
	virtual DWORD Window::getWindowStyle();

	virtual LRESULT windowProc(UINT uMsg, WPARAM wParam, LPARAM lParam);

	virtual void wmMove(int x, int y);
	virtual void wmSize(WPARAM wParam, int width, int height);
	virtual void wmSizing(WPARAM wParam, int x, int y);
	virtual void wmSysCommand(WPARAM wParam);
	virtual void wmGetMinMaxInfo(MINMAXINFO* info);

public:
	Window();
	virtual ~Window();

	virtual Toolkit* getToolkit() const;
	virtual void addNotify();

	void setIcon(HICON smallIcon, HICON largeIcon);

	void setMinimumSize(Dimension minimumSize);

	virtual void setVisible(bool visible);
	// void setVisible(int nCmdShow);
	void pack();

	void dispose();

	void addWindowListener(WindowListener* listener);
	void removeWindowListener(WindowListener* listener);

protected:
	void fireWindowClosing();

private:
	void notifyMouseOwned(Component* mouseOwner, int x, int y);

	friend class Component;
};


} // namespace


#endif // __AWT_WINDOW_H__
