// AWT less.


#ifndef __AWT_ACTION_LISTENER_H__
#define __AWT_ACTION_LISTENER_H__


#include "ActionEvent.h"


namespace awt {


// interface
class ActionListener {
public:
	virtual void actionPerformed(ActionEvent& event) = 0;
};

template<typename E>
class action_mem_fun : public ActionListener {
private:
	E* p;
	void (E::*pm)();
public:
	action_mem_fun(E* p, void (E::*pm)()) : p(p), pm(pm) {}
	void actionPerformed(ActionEvent& event) {
		(p->*pm)();
	}
};


} // namespace


#endif // __AWT_ACTION_LISTENER_H__
