// AWT less.


#ifndef __AWT_ADJUSTMENT_EVENT_H__
#define __AWT_ADJUSTMENT_EVENT_H__


#include "../../util/EventObject.h"
#include "../Component.h"


namespace awt {


class AdjustmentEvent : public EventObject<Component*> {
public:
	enum Type {
		TRACK,
		UNIT_INCREMENT,
		UNIT_DECREMENT,
		BLOCK_INCREMENT,
		BLOCK_DECREMENT
	};

private:
	const Type type;
	const int value;

public:
	AdjustmentEvent(Component* source, Type type, int value);
	Type getAdjustmentType() const;
	int getValue() const;
};


} // namespace


#endif // __AWT_ADJUSTMENT_EVENT_H__
