// AWT less.


#ifndef __AWT_CONTAINER_EVENT_H__
#define __AWT_CONTAINER_EVENT_H__


#include "../../util/EventObject.h"


namespace awt {


class Component;
class Container;


class ContainerEvent : public EventObject<Container*> {
public:
	enum Type {
		ADD = 1,
		REMOVE = -1
	};

private:
	const Type type;
	Component* const child;

public:
	ContainerEvent(Container* source, Type type, Component* child);
	Type getType() const;
	Component* getChild() const;
};


} // namespace


#endif // __AWT_CONTAINER_EVENT_H__
