// AWT less.


#ifndef __AWT_ITEM_LISTENER_H__
#define __AWT_ITEM_LISTENER_H__


#include "ItemEvent.h"


namespace awt {


// interface
class ItemListener {
public:
	virtual void itemStateChanged(ItemEvent& event) = 0;
};

template<typename E>
class item_mem_fun : public ItemListener {
private:
	E* p;
	void (E::*pm)();
public:
	item_mem_fun(E* p, void (E::*pm)()) : p(p), pm(pm) {}
	void itemStateChanged(ItemEvent& event) {
		(p->*pm)();
	}
};


} // namespace


#endif // __AWT_ITEM_LISTENER_H__
