// AWT less.


#ifndef __AWT_KEY_EVENT_H__
#define __AWT_KEY_EVENT_H__


#include "../../util/EventObject.h"

#include <windows.h>


namespace awt {


class Component;


class KeyEvent : public EventObject<Component*> {
public:
	enum Type {
		PRESSED,
		RELEASED,
		TYPED
	};

	static const int SHIFT_MASK;
	static const int CTRL_MASK;
	static const int ALT_MASK;

	static Type messageToType(UINT uMsg);

private:
	const Type type;
	const int keyCode;
	const int modifires;

public:
	KeyEvent(Component* source, Type type, int keyCode);
	Type getType() const;
	int getKeyCode() const;
	int getModifiers() const;
};


} // namespace


#endif __AWT_KEY_EVENT_H__
