// AWT less.


#ifndef __AWT_MOUSE_EVENT_H__
#define __AWT_MOUSE_EVENT_H__


#include "../../util/EventObject.h"


namespace awt {


class Component;


class MouseEvent : public EventObject<Component*> {
public:
	enum Type {
		ENTERED,
		EXITED,
		PRESSED
	};
	enum Button {
		BUTTON_NO = 0,
		BUTTON_L,
		BUTTON_R,
		BUTTON_M
	};

private:
	const Type type;
	const Button button;
	const int x;
	const int y;

public:
	MouseEvent(Component* source, Type type, Button button, int x, int y);
	Type getType() const;
	Button getButton() const;
	int getX() const;
	int getY() const;
};


} // namespace


#endif // __AWT_MOUSE_EVENT_H__
