// AWT less.


#ifndef __AWT_TYPES_H__
#define __AWT_TYPES_H__


#include <windows.h>


namespace awt {


class Point {
public:
	int x;
	int y;

	Point() : x(0), y(0) {};
	Point(int x, int y) : x(x), y(y) {}
};


class Dimension {
public:
	int width;
	int height;

	Dimension() : width(0), height(0) {}
	Dimension(int width, int height) : width(width), height(height) {}
};


class Insets {
public:
	int top;
	int left;
	int bottom;
	int right;

	Insets() : top(0), left(0), bottom(0), right(0) {}
	Insets(int top, int left, int bottom, int right)
			: top(top), left(left), bottom(bottom), right(right) {}
};


class auto_hdc {
private:
	HWND hwnd;
	HDC hdc;
public:
	explicit auto_hdc(HWND hwnd) : hwnd(hwnd), hdc(::GetDC(hwnd)) {}
	~auto_hdc() { ::ReleaseDC(hwnd, hdc); }
	operator HDC() { return hdc; }
private:
	auto_hdc(const auto_hdc&);
	auto_hdc& operator=(const auto_hdc&);
};


} // namespace


#endif // __AWT_TYPES_H__
