// tuneapp.


#ifndef __LANG_H__
#define __LANG_H__


#pragma warning(disable:4250)
#pragma warning(disable:4786)


#include <string>
using namespace std;


extern const wstring NULL_STRING;


class Exception : public exception {
private:
	wstring message;
public:
	Exception(const wstring& message);
	const wstring& getMessage() const;
};

class IllegalArgumentException : public Exception {
public:
	IllegalArgumentException(const wstring& message);
};

class NumberFormatException : public Exception {
public:
	NumberFormatException(const wstring& message);
};

class SecurityException : public Exception {
public:
	SecurityException(const wstring& message);
};

wstring toString(int value);

int parseInt(const wstring& string) throw(NumberFormatException);
bool parseBool(const wstring& string) throw(NumberFormatException);

bool startsWith(const wstring& string, const wchar_t* pattern);
bool startsWith(const wstring& string, const wstring& pattern);
bool startsWithIgnoreCase(const wstring& string, const wchar_t* pattern);

bool endsWith(const wstring& string, const wchar_t* pattern);
bool endsWithIgnoreCase(const wstring& string, const wchar_t* pattern);
bool equalsIgnoreCase(const wstring& string, const wchar_t* pattern);

wstring toLowerCase(const wstring& src);
wstring trim(const wstring& src);

template<typename E>
bool equalsIgnoreCase(E* string1, E* string2, size_t length) {
	for (int i = 0; i < length; i++) {
		if (tolower(*(string1 + i)) != tolower(*(string2 + i))) {
			return false;
		}
	}
	return true;
};

#endif // __LANG_H__
