// tuneapp.


#ifndef __ABSTRACT_REG_BIT_VALUE_H__
#define __ABSTRACT_REG_BIT_VALUE_H__


#include "AbstractRegItem.h"


class AbstractRegBitValueItem : public AbstractRegItem {
private:
	int defaultValue;
	int systemValue;
	int currentValue;

protected:
	AbstractRegBitValueItem();

public:
	virtual void setParams(xml::Node* params) throw(ConfigException);

	virtual void setDefault();
	virtual void apply() throw(RegKeyException);
	virtual void cancel();

private:
	void init();

protected:
	virtual void readRegistry();
	virtual int readRegistry(RegKey* key) throw(RegKeyException);
	virtual void writeRegistry() throw(RegKeyException);
	virtual void writeRegistry(RegKey* key, int value) throw(RegKeyException);
	virtual int getSystemValue() const;
	virtual int getDefaultValue() const;
	virtual int getCurrentValue() const;
	virtual void setCurrentValue(int currentValue);

	virtual void store(RegistryStorage* storage);
};


#endif // __ABSTRACT_REG_BIT_VALUE_H__
