// tuneapp.


#ifndef __ABSTRACT_REG_CHECK_ITEM_H__
#define __ABSTRACT_REG_CHECK_ITEM_H__


#include "AbstractRegItem.h"
#include "../CheckItem.h"


class AbstractRegCheckItem : public AbstractRegItem, public CheckItem {
protected:
	bool defaultValue;
	bool systemValue;
	bool currentValue;
	wstring label;

protected:
	AbstractRegCheckItem();

public:
	virtual void setParams(xml::Node* params) throw(ConfigException);

	virtual awt::Component* getViewComponent();

public:
	bool getSystemValue() const;
	bool getCurrentValue() const;
	bool getDefaultValue() const;
	void setDefaultValue(bool defaultValue);
	void setCurrentValue(bool value);
	const wstring& getLabel() const;

	virtual void setDefault();
	virtual void apply() throw(RegKeyException);
	virtual void cancel();

protected:
	virtual void readRegistry();
	virtual bool readRegistry(RegKey* key) throw(RegKeyException) = 0;
	virtual void writeRegistry() throw(RegKeyException);
	virtual void writeRegistry(RegKey* key, bool value) throw(RegKeyException) = 0;
};


#endif // __ABSTRACT_REG_CHECK_ITEM_H__
