// tuneapp.


#ifndef __ABSTRACT_REG_ITEM_H__
#define __ABSTRACT_REG_ITEM_H__


#include "../AbstractItem.h"

#include "RegKey.h"

#include <string>
#include <vector>
using namespace std;


class AbstractRegItem : public AbstractItem {
private:
	wstring regKey;
	wstring regValue;
	DWORD regType;
	wstring defaultValue;
	wstring defaultMean;
	bool deleteForDefault;

protected:
	mutable wstring shortHelp;

protected:
	AbstractRegItem();

public:
	virtual void setParams(xml::Node* params) throw(ConfigException);
	const wstring& getRegKeyName() const;
	const wstring& getRegValueName() const;
	DWORD getRegType() const;
	virtual const wstring& getShortHelpText() const;

	virtual void store(Storage* storage);

protected:
	void setRegKeyName(const wstring& regKey);
	void setRegValueName(const wstring& regValue);
	RegKey* openRegKey(REGSAM access) const throw(RegKeyException);
	const wstring& getDefaultValueString() const;
	const wstring& getDefaultMeanString() const;
	bool isDeleteForDefault() const;
	void setDeleteForDefault(bool deleteForDefault);

	virtual void store(RegistryStorage* storage) = 0;

	static DWORD getRegType(const wstring& typeString);
	static BYTE* hexStringToBytes(const wstring& string, int* length) throw(IllegalArgumentException);
	static void bytesToHexString(const BYTE* bytes, int length, wstring* string);
};


#endif // __ABSTRACT_REG_ITEM_H__
