// tuneapp.


#ifndef __ABSTRACT_REG_VALUE_H__
#define __ABSTRACT_REG_VALUE_H__


#include "AbstractRegItem.h"
#include "../ValueItem.h"

#include <string>
using namespace std;


class AbstractRegValueItem : public AbstractRegItem, public virtual ValueItem {
private:
	int minValue;
	int maxValue;
	int valueSteps;
	int blockSteps;
	int scale;
	wstring unit;
	int defaultValue;
	int defaultMean;
	int systemValue;
	int currentValue;

protected:
	AbstractRegValueItem();

public:
	virtual void setParams(xml::Node* params) throw(ConfigException);
	int getSystemValue() const;
	int getCurrentValue() const;
	void setCurrentValue(int currentValue);
	int getDefaultValue() const;
	int getDefaultMean() const;
	int getMinimumValue() const;
	int getMaximumValue() const;
	int getValueSteps() const;
	int getBlockSteps() const;
	int getScale() const;
	const wstring& getUnit() const;

	virtual void setDefault();
	virtual void apply() throw(RegKeyException);
	virtual void cancel();

	virtual awt::Component* getViewComponent();

private:
	void init();

protected:
	virtual void readRegistry();
	virtual int readRegistry(RegKey* key) throw(RegKeyException) = 0;
	virtual void writeRegistry() throw(RegKeyException);
	virtual void writeRegistry(RegKey* key, int value) throw(RegKeyException) = 0;

	void setDefaultValue(int defaultValue);
};


#endif // __ABSTRACT_REG_VALUE_H__
