// tuneapp


#include "DiskPerformanceCounterItem.h"

#include "../utils.h"


DiskPerformanceCounterItem::DiskPerformanceCounterItem() {
}

void DiskPerformanceCounterItem::setParams(xml::Node* params) throw(ConfigException) {
	for (	xml::Node::const_iterator children = params->begin();
			children != params->end();
			++children) {
		xml::Node* child = *children;
		if (child->getType() == xml::Node::ELEMENT) {
			const wstring& name = child->getName();
			if (name == L"true") {
				trueArgs = child->getText();
			} else if (name == L"true") {
				falseArgs = child->getText();
			}
		}
	}
	RegMultiStringCheckItem::setParams(params);
}

void DiskPerformanceCounterItem::apply() throw(RegKeyException) {
	bool changed = isChanged();
	RegMultiStringCheckItem::apply();
	if (changed) {
		wstring command = utils::concatPath(utils::getSystemDirectory(), L"diskperf.exe");
		bool value = getCurrentValue();
		if (value) {
			utils::exec(command, trueArgs);
		} else {
			utils::exec(command, falseArgs);
		}
	}
}

void DiskPerformanceCounterItem::store(Storage* storage) {
}

void DiskPerformanceCounterItem::store(RegistryStorage* storage) {
	assert (false);
}
