// tuneapp.


#ifndef __PRIORITY_CONTROL_ITEM_H__
#define __PRIORITY_CONTROL_ITEM_H__


#include "AbstractRegBitValueItem.h"

#include "../awt/Component.h"
#include "../awt/Panel.h"
#include "../awt/Checkbox.h"
#include "../awt/event/ItemListener.h"

#include <vector>
using namespace std;


class PriorityControlItem : public AbstractRegBitValueItem {
private:
	bool server;
	wstring lengthName;
	vector<wstring> lengthLabels;
	wstring boostName;
	vector<wstring> boostLabels;

public:
	PriorityControlItem();
	virtual void setParams(xml::Node* params) throw(ConfigException);
private:
	void setLengthParams(xml::Node* params);
	void setBoostParams(xml::Node* params);

public:
	bool isShortLength() const;
	void setShortLength(bool shortLength);
	int getBoost() const;
	void setBoost(int boost);

	virtual awt::Component* getViewComponent();

private:
	class View : public awt::Panel {
	private:
		PriorityControlItem* const target;
		vector<awt::Checkbox*> lengthCheckbox;
		vector<awt::Checkbox*> boostCheckbox;
	public:
		View(PriorityControlItem* target);
	private:
		void createComponents();

	public:
		class LengthSetter : public awt::ItemListener {
		private:
			PriorityControlItem* target;
			bool shortLength;
		public:
			LengthSetter(PriorityControlItem* target, bool shortLength);
			void itemStateChanged(awt::ItemEvent& event);
		};

		class BoostSetter : public awt::ItemListener {
		private:
			PriorityControlItem* target;
			int boost;
		public:
			BoostSetter(PriorityControlItem* target, int boost);
			void itemStateChanged(awt::ItemEvent& event);
		};
	};
	friend class View;
	friend class View::LengthSetter;
	friend class View::BoostSetter;
};


#endif // __PRIORITY_CONTROL_ITEM_H__
