// tuneapp.


#ifndef __REG_DELETE_SUB_KEYS_ITEM_H__
#define __REG_DELETE_SUB_KEYS_ITEM_H__


#include "AbstractRegCheckItem.h"

#include "../IOException.h"

#include <set>
using namespace std;


class RegDeleteSubKeysItem : public AbstractRegCheckItem {
private:
	set<wstring> saveSubKeyList;
	bool cantOperation;
	bool cantExport;
	wstring backupName;

public:
	RegDeleteSubKeysItem();
	virtual void setParams(xml::Node* params) throw(ConfigException);

	virtual awt::Component* getViewComponent();

	virtual void apply() throw(RegKeyException);

private:
	void setSaveParams(xml::Node* params);
	void addSaveSubKey(const wstring& subkey);
	bool isSaveSubKey(const wstring& subkey) const;
	void init();
	bool checkBackupFile() const;

protected:
	virtual void readRegistry();
	virtual bool readRegistry(RegKey* key) throw(RegKeyException);
	virtual void writeRegistry() throw(RegKeyException, IOException);
	virtual void writeRegistry(RegKey* key, bool value) throw(RegKeyException);
	void backupRegistry() throw(RegKeyException, IOException);
	void deleteRegistry() throw(RegKeyException);
	void deleteRegistry(RegKey* key) throw(RegKeyException);
	void importBackupFile() throw(IOException);

	virtual void store(RegistryStorage* storage);
};


#endif // __REG_DELETE_SUB_KEYS_ITEM_H__
