// tuneapp.


#include "RegKeyItem.h"

#include "../ConfigReader.h"


RegKeyItem::RegKeyItem() {
}

void RegKeyItem::setParams(xml::Node* params) throw(ConfigException) {
	AbstractRegCheckItem::setParams(params);

	init();
}

void RegKeyItem::init() throw(ConfigException) {
	if (getRegType() != REG_SZ) {
		throw ConfigException(L"support only REG_SZ");
	}
	defaultValue = parseBool(getDefaultValueString());

	readRegistry();
}

void RegKeyItem::readRegistry() {
	try {
		delete openRegKey(KEY_READ);
		systemValue = true;
	} catch (RegKeyException) {
		systemValue = false;
	}
	currentValue = systemValue;
}

bool RegKeyItem::readRegistry(RegKey* key) throw(RegKeyException) {
	assert (false);
	return false;
}

void RegKeyItem::apply() throw(RegKeyException) {
	if (currentValue == systemValue) return;

	if (currentValue) {
		writeRegistry();
	} else {
		deleteRegistry();
	}
	systemValue = currentValue;
	setChanged();
}

void RegKeyItem::writeRegistry() throw(RegKeyException) {
	auto_ptr<RegKey> key(openRegKey(KEY_WRITE | KEY_READ));
	key->setValue(NULL_STRING, REG_SZ, getRegValueName());
}

void RegKeyItem::writeRegistry(RegKey* key, bool value) throw(RegKeyException) {
	assert (false);
}

void RegKeyItem::deleteRegistry() throw(RegKeyException) {
	RegKey::deleteKeyIfExists(getRegKeyName());
}

void RegKeyItem::store(RegistryStorage* storage) {
	if (currentValue) {
		RegistryStorage::Key* key = storage->getKey(getRegKeyName());
		key->setSZ(NULL_STRING, getRegValueName());
	} else {
		storage->deleteKey(getRegKeyName());
	}
}
