// tuneapp.


#ifndef __REG_MULTI_LIST_VALUE_ITEM_H__
#define __REG_MULTI_LIST_VALUE_ITEM_H__


#include "RegMultiValueItem.h"
#include "../ValueItem.h"


class RegMultiListValueItem : public RegMultiValueItem {
private:
	int entryIndex;

public:
	RegMultiListValueItem();
	virtual void setParams(xml::Node* params) throw(ConfigException);

protected:
	virtual int readRegistry(RegKey* regKey) throw(RegKeyException);
	virtual void writeRegistry(RegKey* key, int value) throw(RegKeyException);

	virtual void store(RegistryStorage* storage);

private:
	wstring createValueString(const wstring& systemValueString, int value) const throw(IllegalArgumentException);

	static vector<wstring>* parseValueList(const wstring& string, vector<wstring>* valueList);
};


#endif // __REG_MULTI_LIST_VALUE_ITEM_H__
