// tuneapp.


#ifndef __REG_MULTI_STRING_CHECK_ITEM_H__
#define __REG_MULTI_STRING_CHECK_ITEM_H__


#include "AbstractRegCheckItem.h"

#include <string>
using namespace std;


class RegMultiStringCheckItem : public AbstractRegCheckItem {
private:
	static const wstring MULTI_SZ_TERM;

private:
	wstring checkPattern;

public:
	RegMultiStringCheckItem();

	virtual void setParams(xml::Node* params) throw(ConfigException);

private:
	void init();

protected:
	virtual bool readRegistry(RegKey* key) throw(RegKeyException);
	using AbstractRegCheckItem::readRegistry;
	virtual void writeRegistry(RegKey* key, bool value) throw(RegKeyException);
	using AbstractRegCheckItem::writeRegistry;

	virtual void store(RegistryStorage* storage);

private:
	wstring::size_type findPatternMatch(const wstring& systemValueString);
	wstring createValueString(const wstring& systemValueString, bool value);
};


#endif // __REG_MULTI_STRING_CHECK_ITEM_H__
