// tuneapp.


#ifndef __REG_MULTI_VALUE_ITEM_H__
#define __REG_MULTI_VALUE_ITEM_H__


#include "AbstractRegValueItem.h"
#include "../ValueItem.h"

#include <string>
using namespace std;


class RegMultiValueItem : public AbstractRegValueItem {
private:
	wstring entryName;
	wstring correctiveValueString;

public:
	RegMultiValueItem();
	virtual void setParams(xml::Node* params) throw(ConfigException);

	const wstring& getRegValueEntryName() const;

protected:
	const wstring& getCorrectiveValueString() const;
	virtual int readRegistry(RegKey* key) throw(RegKeyException);
	virtual void writeRegistry(RegKey* key, int value) throw(RegKeyException);

	virtual void store(RegistryStorage* storage);

	static map<wstring, wstring>* parseValueMap(const wstring& string, map<wstring, wstring>* valueMap);

private:
	wstring createValueString(const wstring& systemValueString, int value) const;
};


#endif // __REG_MULTI_VALUE_ITEM_H__
