// tuneapp.


#ifndef __REG_TOGGLE_ITEM_H__
#define __REG_TOGGLE_ITEM_H__


#include "AbstractRegItem.h"
#include "../ToggleItem.h"


class RegToggleItem : public AbstractRegItem, public virtual ToggleItem {
private:
	vector<wstring> valuesString;
	vector<wstring> labels;

	int defaultSelection;
	int systemSelection;
	int currentSelection;

public:
	RegToggleItem();
	virtual void setParams(xml::Node* params) throw(ConfigException);
private:
	void setSelectParams(xml::Node* params) throw(ConfigException);
	void init() throw(ConfigException);

public:
	int getSystemSelection() const;
	int getCurrentSelection() const;
	int getDefaultSelection() const;
	int getCountItems() const;
	void setCurrentSelection(int currentSelection);
	const wstring& getLabel(int index) const;

	virtual void setDefault();
	virtual void apply() throw(RegKeyException);
	virtual void cancel();

	virtual awt::Component* getViewComponent();

protected:
	virtual void readRegistry();
	virtual int readRegistry(RegKey* key) throw(RegKeyException);
	virtual void writeRegistry() throw(RegKeyException);
	virtual void writeRegistry(RegKey* key) throw(RegKeyException);

	virtual void store(RegistryStorage* storage);
};


#endif // __REG_TOGGLE_ITEM_H__
