// tuneapp.


#ifndef __NIC_ENUMERATOR_H__
#define __NIC_ENUMERATOR_H__


#include "../../ItemGroupSelector.h"
#include "../../ConfigReader.h"
#include "NICParameterItem.h"

#include <string>
#include <vector>
#include <map>
using namespace std;


class NICEnumerator : public ItemGroupSelector {
private:
	struct NIC {
	public:
		wstring id;
		wstring name;
		wstring regKey;
		ItemGroupList groupList;
	};

	wstring label;

	wstring regEnumKey;
	wstring regEnumClassidValue;
	vector<wstring> regEnumNameValues;
	wstring regInterfacesKey;

	vector<wstring> keyList;
	map<wstring, NIC> nicMap;

	static const wstring GLOBAL_ID;

public:
	NICEnumerator();

	virtual void setParams(xml::Node* params) throw(ConfigException);
private:
	void setNameValuesParams(xml::Node* params) throw(ConfigException);
	void setGlobalParams(xml::Node* params) throw(ConfigException);
	void setInterfacesParams(xml::Node* params) throw(ConfigException);
	void init() throw(RegKeyException);
	void getNICs() throw(RegKeyException);
	void addNIC(NIC& nic);

public:
	virtual void addGroup(ItemGroup* templateGroup);
	virtual const vector<wstring>& keys() const;
	virtual const wstring& getLabel() const;
	virtual const wstring& getLabel(const wstring& key) const;
	virtual const ItemGroupList& getItemGroupList(const wstring& key) const;
	virtual const wstring& getShortHelpText() const;
};


#endif // __NIC_ENUMERATOR_H__
