// tuneapp.


#ifndef __RFC1323OPTS_ITEM_H__
#define __RFC1323OPTS_ITEM_H__


#include "../AbstractRegBitValueItem.h"

#include "../../awt/Panel.h"
#include "../../awt/Checkbox.h"
#include "../../awt/event/ItemListener.h"


class RFC1323OptsItem : public AbstractRegBitValueItem {
private:
	wstring windowScalingLabel;
	wstring timestampingLabel;

	int defaultValue;
	int systemValue;
	int currentValue;

public:
	RFC1323OptsItem();
	void setParams(xml::Node* params) throw(ConfigException);
private:
	void setWindowSaclingParams(xml::Node* params);
	void setTimestampingParams(xml::Node* params);

public:
	bool isWindowScalingEnabled();
	void setWindowScalingEnabled(bool enabled);
	bool isTimestampingEnabled();
	void setTimestampingEnabled(bool enabled);

	virtual awt::Component* getViewComponent();

private:
	class View : public awt::Panel {
	private:
		RFC1323OptsItem* const target;
		awt::Checkbox* windowScalingCheckbox;
		awt::Checkbox* timestampingCheckbox;
	public:
		View(RFC1323OptsItem* target);
	private:
		void createComponents();

		class WindowScalingListener : public awt::ItemListener {
		private:
			View* const view;
		public:
			WindowScalingListener(View* view) : view(view) {}
			void itemStateChanged(awt::ItemEvent& event);
		};
		class TimestampingListener : public awt::ItemListener {
		private:
			View* const view;
		public:
			TimestampingListener(View* view) : view(view) {}
			void itemStateChanged(awt::ItemEvent& event);
		};
		friend class WindowScalingListener;
		friend class TimestampingListener;
	};
	friend class View;
};


#endif // __RFC1323OPTS_ITEM_H__
