// tuneapp


#ifndef __TYPES_H__
#define __TYPES_H__


#include <string>
#include <vector>
using namespace std;

#include <windows.h>

#include <assert.h>


extern const wstring UNICODE_MARK_LITTLE;
extern const wstring LN;


template<typename T>
class auto_array {
private:
	T* array;
public:
	explicit auto_array(size_t size) : array(NULL) { array = new T[size]; }
	explicit auto_array(T* ptr) : array(ptr) { assert(ptr != NULL); }
	~auto_array() { delete[] array; }
	operator T*() { return array; }
	T* ptr() { return array; };
	// size_t size() { return sizeof; }
private:
	auto_array(const auto_array&);
	auto_array& operator=(const auto_array&);
};

class auto_handle {
private:
	HANDLE h;
public:
	explicit auto_handle(HANDLE h = INVALID_HANDLE_VALUE) : h(h) {}
	~auto_handle() { if (h != INVALID_HANDLE_VALUE) ::CloseHandle(h); }
	operator HANDLE() { return h; }
	HANDLE* operator &() { return &h; };
	HANDLE handle() { return h; }
private:
	auto_handle(const auto_handle&);
	auto_handle& operator=(const auto_handle&);
};

class auto_findfile {
private:
	HANDLE h;
public:
	explicit auto_findfile(HANDLE h = INVALID_HANDLE_VALUE) : h(h) {}
	~auto_findfile() { if (h != INVALID_HANDLE_VALUE) ::FindClose(h); }
	operator HANDLE() { return h; }
	HANDLE* operator &() { return &h; };
	HANDLE handle() { return h; }
private:
	auto_findfile(const auto_handle&);
	auto_findfile& operator=(const auto_handle&);
};


class Category;
class Item;
class ItemGroup;

typedef vector<Category*> CategoryList;
typedef vector<Item*> ItemList;
typedef vector<ItemGroup*> ItemGroupList;


#endif // __TYPES_H__
