// tuneapp.


#ifndef __INHERIT_CHECK_ITEM_VIEW_H__
#define __INHERIT_CHECK_ITEM_VIEW_H__


#include "../CheckItem.h"
#include "../Inheritable.h"

#include "../awt/Panel.h"
#include "../awt/Checkbox.h"
#include "../awt/event/ItemListener.h"
#include "../util/PropertyChangeListener.h"


class InheritCheckItemView : public awt::Panel {
private:
	CheckItem* const item;
	Inheritable* const inheritor;

	awt::Checkbox* inheritCheckbox;
	awt::Checkbox* checkbox;

public:
	InheritCheckItemView(CheckItem* item);
	CheckItem* getTargetItem();

private:
	void createComponents();

	class InheritCheckboxListener : public awt::ItemListener {
	private:
		InheritCheckItemView* target;
	public:
		InheritCheckboxListener(InheritCheckItemView* target) : target(target) {}
		void itemStateChanged(awt::ItemEvent& event);
	};
	friend class InheritCheckboxListener;

	class CheckboxListener : public awt::ItemListener {
	private:
		InheritCheckItemView* target;
	public:
		CheckboxListener(InheritCheckItemView* target) : target(target) {}
		void itemStateChanged(awt::ItemEvent& event);
	};
	friend class CheckboxListener;

	class ItemPropertyChangeListener : public PropertyChangeListener {
	private:
		InheritCheckItemView* target;
	public:
		ItemPropertyChangeListener(InheritCheckItemView* target) : target(target) {}
		void propertyChange(PropertyChangeEvent& event);
	};
	friend class ItemPropertyChangeListener;
};


#endif // __INHERIT_CHECK_ITEM_VIEW_H__
