// tuneapp.


#ifndef __RECURSIVE_LISTENER_H__
#define __RECURSIVE_LISTENER_H__


#include "../awt/Container.h"
#include "../awt/event/ContainerListener.h"


class RecursiveListener : public virtual awt::ContainerListener {
protected:
	awt::Component* target;

	virtual void installDispatcherTo(awt::Component* component) = 0;
	virtual void uninstallDispatcherFrom(awt::Component* component) = 0;

public:
	RecursiveListener();

	void installTo(awt::Component* target);
	void uninstall();
	void installRecursive(awt::Component* target);
	void uninstallRecursive(awt::Component* target);

	void componentAdded(awt::ContainerEvent& event);
	void componentRemoved(awt::ContainerEvent& event);
};


#endif // __RECURSIVE_LISTENER_H__
