// tuneapp.


#include "ToggleItemView.h"

#include "../awt/Checkbox.h"

#include "../utils.h"


ToggleItemView::ToggleItemView(ToggleItem* item) : item(item) {
	createComponents();
}

void ToggleItemView::createComponents() {
	setLayout(utils::leftFlowLayout);

	int count = item->getCountItems();
	int currentSelection = item->getCurrentSelection();
	for (int i = 0; i < count; i++) {
		const wstring& label = item->getLabel(i);
		awt::Checkbox* checkbox
				= new awt::Checkbox(label, (i == currentSelection), this);
		add(checkbox);
		checkbox->addItemListener(new SelectionListener(this, i));
	}
}

ToggleItemView::SelectionListener::SelectionListener(ToggleItemView* target, int selection)
		: target(target), selection(selection) {
}

void ToggleItemView::SelectionListener::itemStateChanged(awt::ItemEvent& event) {
	target->item->setCurrentSelection(selection);
}

ToggleItem* ToggleItemView::getTargetItem() {
	return item;
}
