// tuneapp.


#ifndef __TOGGLE_ITEM_VIEW_H__
#define __TOGGLE_ITEM_VIEW_H__


#include "../ToggleItem.h"

#include "../awt/CheckboxGroup.h"
#include "../awt/GridFlowLayout.h"
#include "../awt/event/ItemListener.h"


class ToggleItemView : public awt::CheckboxGroup {
private:
	ToggleItem* const item;

public:
	ToggleItemView(ToggleItem* item);
	ToggleItem* getTargetItem();

private:
	void createComponents();

	class SelectionListener : public awt::ItemListener {
	private:
		ToggleItemView* const target;
		const int selection;
	public:
		SelectionListener(ToggleItemView* target, int selection);
		void itemStateChanged(awt::ItemEvent& event);
	};
	friend class SelectionListener;
};


#endif // __TOGGLE_ITEM_VIEW_H__
