// Rick DOM.


#ifndef __XML_DOCUMENT_BUILDER_H__
#define __XML_DOCUMENT_BUILDER_H__


#include "ParserCallback.h"

#include "Document.h"
#include "Node.h"


namespace xml {


class DocumentBuilder : public ParserCallback {
protected:
	Document* const document;
	Node* currentNode;

public:
	DocumentBuilder(Document* document);

	void startElement(const wstring& name, const Attributes& attrs) throw(Exception);
	void endElement(const wstring& name) throw(Exception);
	void text(const wstring& text) throw(Exception);
	void endDocument() throw(Exception);
};


} // namespace


#endif // __XML_DOCUMENT_BUILDER_H__
