// Rick DOM.


#ifndef __XML_ELEMENT_H__
#define __XML_ELEMENT_H__


#include "Node.h"


namespace xml {


class Element : public Node {
protected:
	vector<Node*> children;
	Attributes attributes;
	mutable wstring textCache;

protected:
	Element(Type type, const wstring& name);
public:
	Element(const wstring& name);
	virtual ~Element();

	virtual void add(Node* node) throw(Exception);
	virtual int getChildCount() const;
	virtual const_iterator begin() const;
	virtual const_iterator end() const;

	virtual void setAttribute(const wstring& attr, const wstring& value) throw(Exception);
	virtual const wstring& getAttribute(const wstring& attr) const;
	virtual const Attributes& getAttributes() const;
	virtual bool hasAttribute(const wstring& attr) const;

	virtual const wstring& getText() const;
};


} // namespace


#endif // __XML_ELEMENT_H__
