// Rick DOM.


#include "EntityTable.h"


namespace xml {


EntityTable::EntityTable() {
	set(L"amp", L"&");
	set(L"lt", L"<");
	set(L"gt", L">");
	set(L"quot", L"\"");
	set(L"apos", L"\'");
}

const wstring& EntityTable::get(const wstring& name) const {
	Table::const_iterator found = table.find(name);
	if (found == table.end()) {
		return NULL_STRING;
	} else {
		return found->second;
	}
}

void EntityTable::set(const wstring& name, const wstring& value) {
	if (table.find(name) != table.end()) return;
	table[name] = value;
}

bool EntityTable::has(const wstring& name) const {
	return (table.find(name) != table.end());
}


} // namespace
