// Rick DOM.


#ifndef __XML_PARSER_CALLBACK_H__
#define __XML_PARSER_CALLBACK_H__


#include "XMLException.h"

#include <string>
#include <map>
using namespace std;


namespace xml {


// interface
class ParserCallback {
public:
	typedef map<wstring, wstring> Attributes;

public:
	virtual void startElement(const wstring& name, const Attributes& attrs) = 0;
	virtual void endElement(const wstring& name) = 0;
	virtual void text(const wstring& text) = 0;
	virtual void endDocument() = 0;
};


} // namespace


#endif // __XML_PARSER_CALLBACK_H__
