// Rick DOM.


#include "Text.h"


namespace xml {


Node::NodeList Text::emptyChildren;
Node::Attributes Text::emptyAttrs;


Text::Text(const wstring& text) : Node(TEXT, L"#text"), text(text) {
}

const wstring& Text::getText() const {
	return text;
}


void Text::add(Node* node) throw(XMLException) {
	throw XMLException(L"can't add child to text node");
}

int Text::getChildCount() const {
	return 0;
}

Node::const_iterator Text::begin() const {
	return emptyChildren.begin();
}

Node::const_iterator Text::end() const {
	return emptyChildren.end();
}


void Text::setAttribute(const wstring& attr, const wstring& value) throw(XMLException) {
	throw XMLException(L"can't set attribute to text node");
}

const wstring& Text::getAttribute(const wstring& attr) const {
	return NULL_STRING;
}

const Node::Attributes& Text::getAttributes() const {
	return emptyAttrs;
}

bool Text::hasAttribute(const wstring& attr) const {
	return false;
}


} // namespace
