// Rick DOM.


#ifndef __XML_TEXT_H__
#define __XML_TEXT_H__


#include "Node.h"


namespace xml {


class Text : public Node {
private:
	static NodeList emptyChildren;
	static Attributes emptyAttrs;

private:
	const wstring text;

public:
	Text(const wstring& text);

	virtual const wstring& getText() const;

	virtual void add(Node* node) throw(Exception);
	virtual int getChildCount() const;
	virtual const_iterator begin() const;
	virtual const_iterator end() const;

	virtual void setAttribute(const wstring& attr, const wstring& value) throw(Exception);
	virtual const wstring& getAttribute(const wstring& attr) const;
	virtual const Attributes& getAttributes() const;
	virtual bool hasAttribute(const wstring& attr) const;
};


} // namespace


#endif // __XML_TEXT_H__
